# PHPUnitTask

Extends \Task

Runs PHPUnit tests.

Use \Project#createTask to register a new Task.

author | Michiel Rook mrook@php.net
version | $Id: 8db5f2b968a9a111de7bbd1f1ddbc9f5a3c9d55a $
package | phing.tasks.ext.phpunit
see |
since | 2.1.0

### Methods

## Add a new formatter to all tests of this task.

    addFormatter(\FormatterElement $fe)

### Arguments

#### $fe

`\FormatterElement`

## Add a new listener to all tests of this taks

    addListener( $listener)

### Arguments

#### $listener

``

## Add the tests in this batchtest to a test suite

    appendBatchTestToTestSuite(\BatchTest $batchTest, \PHPUnit_Framework_TestSuite $suite)

### Arguments

#### $batchTest

`\BatchTest`

#### $suite

`\PHPUnit_Framework_TestSuite`

## Adds a set of tests based on pattern matching.

    createBatchTest() : \BatchTest

### Response

`\BatchTest`

a new instance of a batch test.

## execute

    execute( $suite)

### Arguments

#### $suite

``

## getDefaultOutput

    getDefaultOutput() : \LogWriter

### Response

`\LogWriter`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getHaltonfailure

    getHaltonfailure() : boolean

### Response

`boolean`

## getHaltonincomplete

    getHaltonincomplete() : boolean

### Response

`boolean`

## getHaltonskipped

    getHaltonskipped() : boolean

### Response

`boolean`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Load and processes the PHPUnit configuration

    handlePHPUnitConfiguration( $configuration) : array

throws |

### Arguments

#### $configuration

``

### Response

`array`

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## loadPHPUnit

    loadPHPUnit()

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets the name of a bootstrap file that is run before executing the tests

    setBootstrap(string $bootstrap)

### Arguments

#### $bootstrap

`string`

the name of the bootstrap file

## setCodecoverage

    setCodecoverage( $codecoverage)

### Arguments

#### $codecoverage

``

## setConfiguration

    setConfiguration(\PhingFile $configuration)

### Arguments

#### $configuration

`\PhingFile`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## setErrorproperty

    setErrorproperty( $value)

### Arguments

#### $value

``

## setExcludeGroups

    setExcludeGroups( $excludeGroups)

### Arguments

#### $excludeGroups

``

## setFailureproperty

    setFailureproperty( $value)

### Arguments

#### $value

``

## setGroups

    setGroups( $groups)

### Arguments

#### $groups

``

## setHaltonerror

    setHaltonerror( $value)

### Arguments

#### $value

``

## setHaltonfailure

    setHaltonfailure( $value)

### Arguments

#### $value

``

## setHaltonincomplete

    setHaltonincomplete( $value)

### Arguments

#### $value

``

## setHaltonskipped

    setHaltonskipped( $value)

### Arguments

#### $value

``

## setIncompleteproperty

    setIncompleteproperty( $value)

### Arguments

#### $value

``

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## setPharLocation

    setPharLocation(string $pharLocation)

### Arguments

#### $pharLocation

`string`

## setPrintsummary

    setPrintsummary( $printsummary)

### Arguments

#### $printsummary

``

## setProcessIsolation

    setProcessIsolation( $processIsolation)

### Arguments

#### $processIsolation

``

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## setSkippedproperty

    setSkippedproperty( $value)

### Arguments

#### $value

``

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## setUseCustomErrorHandler

    setUseCustomErrorHandler( $usecustomerrorhandler)

### Arguments

#### $usecustomerrorhandler

``

### Properties

## batchtests

    batchtests :

### Type(s)

``

## formatters

    formatters :

### Type(s)

``

## bootstrap

    bootstrap :

### Type(s)

``

## haltonerror

    haltonerror :

### Type(s)

``

## haltonfailure

    haltonfailure :

### Type(s)

``

## haltonincomplete

    haltonincomplete :

### Type(s)

``

## haltonskipped

    haltonskipped :

### Type(s)

``

## errorproperty

    errorproperty :

### Type(s)

``

## failureproperty

    failureproperty :

### Type(s)

``

## incompleteproperty

    incompleteproperty :

### Type(s)

``

## skippedproperty

    skippedproperty :

### Type(s)

``

## printsummary

    printsummary :

### Type(s)

``

## testfailed

    testfailed :

### Type(s)

``

## testfailuremessage

    testfailuremessage :

### Type(s)

``

## codecoverage

    codecoverage :

### Type(s)

``

## groups

    groups :

### Type(s)

``

## excludeGroups

    excludeGroups :

### Type(s)

``

## processIsolation

    processIsolation :

### Type(s)

``

## usecustomerrorhandler

    usecustomerrorhandler :

### Type(s)

``

## listeners

    listeners :

### Type(s)

``

## pharLocation

    pharLocation : string

var |

### Type(s)

`string`

## configuration

    configuration : \PhingFile

var |

### Type(s)

`\PhingFile`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`